#include        "AvrX.inc"
/*
        Copyright 1999-2000, Larry Barello
        larry@barello.net

*/
;
; AvrX Time Queue Manager
;
        .section .text.avrx.CANCELTIMER
/*+
; -----------------------------------------------
; pTimerControlBlock
; AvrXCancelTimer(pTimerControlBlock)
;
; Passed:       R25:R24 = TCB
; Returns:      Pointer to removed timer, or 0 if failure
; Uses:
; Stack:        
; Note: walk list looking for TCB.  If found, and not at
;       end of list, then add count to Next tcb.
;
-*/
        .global AvrXCancelTimer
        .func   AvrXCancelTimer
AvrXCancelTimer:
        AVRX_Prolog
        rcall   AvrXIntSetObjectSemaphore

        ldd     R22, Y+_R24
        ldd     R23, Y+_R25
        ldi     Zl, lo8(_TimerQueue)
        ldi     Zh, hi8(_TimerQueue)

        BeginCritical
        rcall   _RemoveObject   ; Z = next item, R23:R22 = obj.
        adiw    Xl, 0           ; End of, or empty list, or null TCB
        breq    act00           ; just drop TCB

        adiw    Xl, TcbCount
        ld      R23, X+
        ld      R22, X
        ldd     R25, Z+TcbCount ; Next
        ldd     R24, Z+TcbCount+1
        add     R24, R22
        adc     R25, R23
        std     Z+TcbCount+1, R24
        std     Z+TcbCount, R25
        rjmp    _Epilog
act00:
        std     Y+_R24, Xl      ; Return 0, failure.
        std     Y+_R25, Xh
        rjmp    _Epilog
        .endfunc

