#include        "AvrX.inc"
/*
        Copyright 1999-2000, Larry Barello
        larry@barello.net

*/

;
; AvrX Time Queue Manager
;
        .section .text.avrx.canceltimermessage
/*+
; -----------------------------------------------
; pTimerControlBlock
; AvrXCancelTimerMessage(pTimerControlBlock, pMessageQueue) CONST
;
; Passed:       R25:R24 = pTimerControlBlock
;               R23:R22 = pMessageQueue
; Returns:      R25:R24 = Pointer to removed timer, or 0 if failure
; Uses:
; Stack:        
; Note: walk list looking for TCB.  If found, and not at
;       end of list, then add count to Next tcb. Else, tries
;       to remove from message queue.
;
-*/
        .global AvrXCancelTimerMessage
        .func   AvrXCancelTimerMessage
AvrXCancelTimerMessage:
        AVRX_Prolog
        mov     R22, R24
        mov     R23, R25
        ldi     Zl, lo8(_TimerQueue)
        ldi     Zh, hi8(_TimerQueue)

        BeginCritical
        rcall   _RemoveObject   ; Z = next item, R23:R22 = obj.
        adiw    Xl, 0           ; End of, or empty list, or null TCB
        breq    actm00           ; just drop TCB

        adiw    Xl, TcbCount
        ld      R23, X+         
        ld      R22, X
        ldd     R25, Z+TcbCount ; Next
        ldd     R24, Z+TcbCount+1
        add     R24, R22
        adc     R25, R23
        std     Z+TcbCount+1, R24
        std     Z+TcbCount, R25
        rjmp    actm01
actm00:
        ldd     Zl, Y+_R22
        ldd     Zh, Y+_R23      ; Recover pointer to queue
        rcall   _RemoveObject   ; R25:R24 still point to TimerMessage
        adiw    Xl, 0
        brne    actm01
        std     Y+_R24, Xl      ; If not found, stuff 0 into return registers
        std     Y+_R25, Xh
actm01:
        rjmp    _Epilog
        .endfunc

