#include        "AvrX.inc"
/*
        Copyright 1999-2000, Larry Barello
        larry@barello.net

*/

        .comm EEPromMutex,      MtxSz

        .section .text.avrx.EEPROMACCESS

/*+
; -----------------------------------------------
; uint8_t AvrXReadEEProm(uint16_t)
;
; Access to the EEPROM by interrupt routines is
; prohibited.
;
; PASSED:       R25:R24 = Address
; RETURNS:      R24 = data
; USES:         EEPromMutex
; NOTE:         Might block waiting for access to EEPROM
-*/
        .global AvrXReadEEProm
        .func   AvrXReadEEProm
        
AvrXReadEEProm:
        mov     R23, R25
        mov     R22, R24
        ldi     R25, hi8(EEPromMutex)
        ldi     R24, lo8(EEPromMutex)
        rcall   AvrXWaitSemaphore
are01:   
        sbic    EECR, EEWE      ; Make sure EEPROM is ready
        rjmp    are01

        out     EEARL, R22
        out     EEARL+1, R23    ; For the 8515
        sbi     EECR, EERE      ; Flag a read operation
        in      R0, EEDR
are00:
        rcall   AvrXSetSemaphore; R25:24 preserved in WaitSem
        clr     R25
        mov     R24, R0
        ret
        .endfunc
/*+
; -----------------------------------------------
; void AvrXWriteEEProm(uint16_t, uint8_t)
;
; PASSED:       R25:R24 = Address
;               R23 = data
; RETURNS:
; USES:         EEPromMutex
; NOTE:         Might block waiting for access to EEPROM
;
-*/
        .global AvrXWriteEEProm
        .func   AvrXWriteEEProm
AvrXWriteEEProm:
        mov     R0, R23         ; Temp save of data
        mov     R22, R24
        mov     R23, R25
        ldi     R25, hi8(EEPromMutex)
        ldi     R24, lo8(EEPromMutex)
        rcall   AvrXWaitSemaphore
awe00:  
        sbic    EECR, EEWE      ; Make sure EEPROM is ready
        rjmp    awe00
        out     EEARL, R22
        out     EEARL+1, R23    ; For the 8515
        out     EEDR, R0
        sbi     EECR, EEMWE
        sbi     EECR, EEWE

        rjmp    AvrXSetSemaphore; R25:24 preserved in WaitSem
        .endfunc


