#include        "AvrX.inc"
/*
        Copyright 1999-2000, Larry Barello
        larry@barello.net

*/
        .section .text.avrx.MESSAGEQUEUEMANAGER
/*+
; --------------------------------------------------
; void AvrXSendMessage(pMessageQueue, pMessageControlBlock)
;
; PASSED:       R25:R24 = Queue head
;               R23:R22 = Message
; RETURNS:      
; USES:         
; CALLS:
; ASSUMES:
; NOTES:
-*/
        .global AvrXSendMessage
        .func AvrXSendMessage
        
AvrXSendMessage:
        AVRX_Prolog
        rcall   AvrXIntSendMessage
        rjmp    _Epilog
        .endfunc
/*+
; --------------------------------------------------
; void AvrXIntSendMessage(pMessageQueue, pMessageControlBlock)
;
; PASSED:       R25:R24 = Queue head
;               R23:R22 = Message
; RETURNS:      
; USES:         Z, Y & some others.  See AvrXIntSetObjectSemaphore
; CALLS:
; ASSUMES:      Called within an _Epilog/_Prolog wrapper
; NOTES:        This could be called from interrupt code
;               but you would need to make sure there is 
;               only one source of messages for that queue
;               or wrap _appendObject in a critical section.
-*/
        .global AvrXIntSendMessage
        .func   AvrXIntSendMessage
AvrXIntSendMessage:
;        rcall   AvrXResetObjectSemaphore
        mov     Zh, R25
        mov     Zl, R24
        rcall   _AppendObject   ; Append the message onto the queue
        rjmp    AvrXIntSetObjectSemaphore
        .endfunc
/*+
; --------------------------------------------------
; pMessageControlBlock AvrXWaitMessage(pMessageQueue)
;
; PASSED:       R25:R24 = Queue head
; RETURNS:      R25:R24 = Message
; USES:         Z, X & flags (See _RemoveFirstObject)
; CALLS:
; ASSUMES:      Null terminated list
; NOTES:        AvrXRecvMessage is atomic for append-only queues
;               just push registers to be saved
-*/
        .global AvrXWaitMessage
        .func   AvrXWaitMessage
AvrXWaitMessage:
        mov     Zl, R24
        mov     Zh, R25
        BeginCritical
        rcall   _RemoveFirstObject
        EndCritical
        adiw    Xl, 0
        brne    _rm01

        rcall   AvrXWaitObjectSemaphore
        sbiw    R24, 2                  ; R24 buggered by WaitObject
        rjmp    AvrXWaitMessage
_rm01:
        adiw    R24, 2
        rcall   AvrXResetSemaphore      ; Clear possible _PEND
        mov     R25, R23
        mov     R24, R22
        ret
        .endfunc

