#include        "AvrX.inc"
/*
        Copyright 1999-2000, Larry Barello
        larry@barello.net

*/
        .section .text.avrx.MESSAGEQUEUEMANAGER
/*+
; --------------------------------------------------
; AvrXRecvMessage
;
; Removes the first item in a queue. Return Zero if empty.
;
; PASSED:       R25, R24 = Queue head
; RETURNS:      R25, R24 = Object = 0 if list empty
; USES:         Z, X, Flags, R23:R22
; CALLS:
; ASSUMES:      Null terminated list
; NOTES:        If queue empty, then reset queue semaphore
;               
;
-*/
        .global AvrXRecvMessage
        .func AvrXRecvMessage
AvrXRecvMessage:
        mov     Zl, R24
        mov     Zh, R25
        BeginCritical
        rcall   _RemoveFirstObject
        mov     R23, Xh
        mov     R22, Xl                 ; R23:22 not updated if message not present
        adiw    R24, 2
        rcall   AvrXResetSemaphore      ; Note, interrupt enabled here
        mov     R24, R22
        mov     R25, R23
        EndCriticalReturn
        .endfunc

