#include        "AvrX.inc"
/*
        Copyright 1999-2000, Larry Barello
        larry@barello.net

*/

        .section .text.avrx.resetsemaphore

/*+
; -----------------------------------------------
; pMutex AvrXResetSemaphore(pMutex)
; pMutex AvrXResetObjectSemaphore(pMutex)
;
; Force a semaphore into the _PEND state.  This is almost identical
; to SetSemaphore, but the end state is always _PEND rather than,
; possibly _DONE
;
; Usable in either USER or KERNEL code.
;
; PASSED:       R25:R24 = Semaphore
; RETURNS:      
; USES:         Z, X, flags
; STACK:
; SIDE EFFECTS: 
; Notes:        It doesn't make sense to reset a semaphore that has
;               a process waiting, so just skip that situation.
-*/
        .global AvrXResetObjectSemaphore
        .func   AvrXResetObjectSemaphore
AvrXResetObjectSemaphore:
        mov     Zl, R24
        mov     Zh, R25
        adiw    Zl, 2
        rjmp    ars00
        .endfunc
        
        .global AvrXResetSemaphore
        .global AvrXIntResetSemaphore
        .func AvrXResetSemaphore
AvrXResetSemaphore:
AvrXIntResetSemaphore:
        mov     Zh, R25
        mov     Zl, R24
ars00:
        BeginCritical
        ldd     Xl, Z+NextL
        ldd     Xh, Z+NextH
        sbiw    Xl, _DONE
        breq    ars01           ; If it was _DONE, now it is _PEND
        adiw    Xl, _DONE       ; otherwize restore Pointer
ars01:
        std     Z+NextH, Xh 
        std     Z+NextL, Xl
        EndCriticalReturn
        .endfunc

