#include        "AvrX.inc"
/*
        Copyright 1999-2000, Larry Barello
        larry@barello.net

*/

        .section .text.avrx.Suspend

/*+
; --------------------------------------------------
; AvrXSuspend
;
; Mark a pid for suspension and attempt to remove from the run queue
;
; AvrXBreakpoint
;
; Suspend Self (Running) if previously suspended (single stepped)
;
; PASSED:       R25:R24 = PID
; RETURNS:      
; USES: 
; ASSUMES:
; NOTES:        Marks PID for suspension.  If removed from the run
;               queue, then marks suspended.  _QueuePid will take care
;               of this for pids queued elsewhere when they become
;               eligable for running.
-*/
        .global AvrXBreakpoint
        .func AvrXBreakpoint
AvrXBreakpoint:
        AVRX_Prolog
        lds     Zh, Running
        lds     Zl, Running+1
        ldd     Xl, Z+PidState
        sbrc    Xl, SuspendBit
        rjmp    as00
        rjmp    _Epilog
        .endfunc

        .global AvrXSuspend
        .func   AvrXSuspend
AvrXSuspend:                    ; User Entry Point
        AVRX_Prolog
        mov     Zh, R25
        mov     Zl, R24
        ldd     Xl, Z+PidState
        sbr     Xl, BV(SuspendBit)      ; Mark process for suspending
        std     Z+PidState, Xl
as00:
        mov     R23, Zh
        mov     R22, Zl
        ldi     Zh, hi8(RunQueue)
        ldi     Zl, lo8(RunQueue)
        BeginCritical
        rcall   _RemoveObject           ; Attempt to remove from run queue
        adiw    Xl, 0
        breq    as01
        
        adiw    Xl, PidState
        ld      Zl, X
        sbr     Zl, BV(SuspendedBit)    ; If found, then mark suspended.
        st      X, Zl
as01:
        rjmp    _Epilog
        .endfunc

