#include        "AvrX.inc"
/*
        Copyright 1999-2000, Larry Barello
        larry@barello.net

*/
        .section .text.avrx.AVRXTASKTERMINATE
        
/*+
; --------------------------------------------------
; AvrXTaskExit
; AvrXTerminate
;
; This is where tasks that "return" come to.  Set the IDLE bit so
; it can not be queued again.  Then attempt to Dequeue from run queue.
; Can not do anything more than that if it is queued on a semaphore...
;
; PASSED:       R25:R24 = Pid to terminate   
; RETURNS:      
; USES:
; CALLS:
; ASSUMES:
; NOTES:        
-*/
        .global AvrXTaskExit
        .func   AvrXTaskExit
AvrXTaskExit:                   ; Entry point for killing self
        AVRX_Prolog             ; Entire state of dying task is on stack
        lds     Zh, Running
        lds     Zl, Running+1
        rjmp    at00
        .endfunc

        .global AvrXTerminate
        .func   AvrXTerminate
AvrXTerminate:                  ; Entry point for killing other tasks.
        AVRX_Prolog
at00:
;       rcall   AvrXIntSetObjectSemaphore       ; Later: Signal parent task
;       sbiw    R24
        mov     Zh, R25
        mov     Zl, R24
        ldi     Xl, BV(IdleBit) ; Mark task dead
        std     Z+PidState, Xl
        mov     R23, R25
        mov     R22, R24
        ldi     Zh, hi8(RunQueue)
        ldi     Zl, lo8(RunQueue)
        BeginCritical
        rcall   _RemoveObject           ; Attempt to remove from run queue
        rjmp    _Epilog

        .endfunc


