#include        "AvrX.inc"
/*
        Copyright 1999-2000, Larry Barello
        larry@barello.net

*/
        
        .section .text.avrx.TESTSEMAPHORE

/*+
;-----------------------------------------------
; AvrXTestSemaphore
; AvrXTIntTestSemaphore
;
; Non blocking call to check state of the Semaphore.
;
; AvrXTestObjectSemaphore
; AvrXTestTimer
; AvrXTestPid
; AvrXTestMessageAck
;
; Non blocking version of AvrXWaitObjectSemaphore
;
; PASSED:       R25:R24 = Semaphore/Object
; RETURNS:      R25:R24 = 0 - _PEND
;                       = 1 - _DONE
;                       = 2 - something is waiting on it.
; USES:         Z, X
; STACK:
; SIDE EFFECTS: 
; NOTES:        Since we don't block, the only valid
;               condition is _DONE.  So, reset to 
;               _PEND and return.
-*/
        .global AvrXTestTimer
        .global AvrXTestPid
        .global AvrXTestMessageAck
        .global AvrXTestObjectSemaphore
        .func   AvrXTestTimer
AvrXTestTimer:
AvrXTestPid:
AvrXTestMessageAck:
AvrXTestObjectSemaphore:
        adiw    R24, 2
        .endfunc
        
        .global AvrXIntTestSemaphore
        .global AvrXTestSemaphore
        .func   AvrXIntTestSemaphore
AvrXIntTestSemaphore:
AvrXTestSemaphore:
        mov     Zh, R25
        mov     Zl, R24
        ldi     R25, hi8(1)
        ldi     R24, lo8(1)     ; Preload _DONE return
        
        BeginCritical
        ldd     Xh, Z+NextH
        ldd     Xl, Z+NextL
        sbiw    Xl, _DONE
        breq    aits01
        
        brlo    aits00          ; if > _DONE return 2
        adiw    R24, 2
aits00:
        sbiw    R24, 1          ; If < _DONE return 0 (was _PEND)
        EndCriticalReturn
aits01:
        std     Z+NextH, Xl     ; Store _PEND (0)
        std     Z+NextL, Xh     ; Return _DONE (R25:R24)
        EndCriticalReturn
        .endfunc
        

